Author: Daniel Lenski <dlenski@gmail.com>
Origin: upstream, https://gitlab.com/openconnect/openconnect/-/commit/7270acd5358e200d39fe13595794f438a701b37a
Description: GlobalProtect IPv6 support
 Turns out that I got *almost* everything right in
 d6db0ec03394234d41fbec7ffc794ceeb486a8f0, including the Ethertype field; the
 only part I overlooked is that `ipv6-support=yes` also needs to be included
 in the `/ssl-vpn/getconfig.esp` request parameters.
--- a/gpst.c
+++ b/gpst.c
@@ -483,7 +483,11 @@
 	for (xml_node = xml_node->children; xml_node; xml_node=xml_node->next) {
 		if (!xmlnode_get_val(xml_node, "ip-address", &s))
 			vpninfo->ip_info.addr = add_option(vpninfo, "ipaddr", &s);
-		else if (!xmlnode_get_val(xml_node, "netmask", &deferred_netmask)) {
+		else if (!xmlnode_get_val(xml_node, "ip-address-v6", &s)) {
+			got_ipv6 |= 1;
+			if (!vpninfo->disable_ipv6)
+				vpninfo->ip_info.addr6 = add_option(vpninfo, "ipaddr6", &s);
+		} else if (!xmlnode_get_val(xml_node, "netmask", &deferred_netmask)) {
 			/* XX: GlobalProtect servers always (almost always?) send 255.255.255.255 as their netmask
 			 * (a /32 host route), and if they want to include an actual default route (0.0.0.0/0)
 			 * they instead put it under <access-routes/>. We defer saving the netmask until later.
@@ -608,15 +612,15 @@
 			   || xmlnode_is_named(xml_node, "bw-c2s")
 			   || xmlnode_is_named(xml_node, "bw-s2c")
 			   || xmlnode_is_named(xml_node, "default-gateway")
+			   || xmlnode_is_named(xml_node, "default-gateway-v6")
 			   || xmlnode_is_named(xml_node, "no-direct-access-to-local-network")
 			   || xmlnode_is_named(xml_node, "ip-address-preferred")
+			   || xmlnode_is_named(xml_node, "ip-address-v6-preferred")
+			   || xmlnode_is_named(xml_node, "ipv6-connection")
 			   || xmlnode_is_named(xml_node, "portal")
 			   || xmlnode_is_named(xml_node, "user")) {
 			/* XX: Do these have any potential value at all for routing configuration or diagnostics? */
 		} else if (xml_node->type == XML_ELEMENT_NODE) {
-			/* XX: Don't know what tags are used for IPv6 addresses and networks, since
-			 * we haven't yet seen a real GlobalProtect VPN with IPv6 internal addresses.
-			 */
 			free(s);
 			s = (char *)xmlNodeGetContent(xml_node);
 			if (strchr((char *)xml_node->name, '6')) {
@@ -663,9 +667,8 @@
 
 	/* Warn about IPv6 config, if present, and ESP config, if absent */
 	if (got_ipv6)
-		vpn_progress(vpninfo, PRG_ERR, _("GlobalProtect config includes IPv6, but this build does not support\n"
-						 "it IPv6 due to a lack of information on how GlobalProtect configures it.\n"
-						 "Please report this to <openconnect-devel@lists.infradead.org>.\n"));
+		vpn_progress(vpninfo, PRG_ERR,
+			     _("GlobalProtect IPv6 support is experimental. Please report results to <openconnect-devel@lists.infradead.org>.\n"));
 
 	free(s);
 	return 0;
@@ -686,6 +689,7 @@
 
 	/* submit getconfig request */
 	buf_append(request_body, "client-type=1&protocol-version=p1&app-version=4.0.5-8");
+	append_opt(request_body, "ipv6-support", vpninfo->disable_ipv6 ? "no" : "yes");
 	append_opt(request_body, "clientos", gpst_os_name(vpninfo));
 	append_opt(request_body, "os-version", vpninfo->platname);
 	append_opt(request_body, "hmac-algo", "sha1,md5,sha256");
